--- old/usr/src/lib/brand/lx/zone/lx_install.ksh	Wed Oct  5 00:33:22 2016
+++ new/usr/src/lib/brand/lx/zone/lx_install.ksh	Wed Oct  5 00:33:22 2016
@@ -10,185 +10,128 @@
 # http://www.illumos.org/license/CDDL.
 #
 # Copyright 2016 Joyent, Inc.  All rights reserved.
+# Copyright 2016 OmniTI Computer Consulting, Inc.  All rights reserved.
 #
 
-#
-# This is only an example install script. It is not currently used for anything.
-#
-
 PATH=/bin:/usr/bin:/usr/sbin
 export PATH
 
-fullpath()
-{
-	typeset path="$1"
+. /usr/lib/brand/shared/common.ksh
 
-	echo $path | egrep -s "^/" || path="${PWD:=$(pwd)}/$path"
-	echo $path
-}
+ZFS_SEED=""
+TAR_SEED=""
 
-makedir()
-{
-	typeset dirname=$(fullpath "$1")
-	typeset mode=""
-
-	[[ $# -eq 2 ]] && mode="-m $2"
-
-	[[ -d "$dirname" ]] && return
-
-	if ! mkdir $mode -p "$dirname"; then
-		echo $(gettext "Aborting installation...")
-		exit 255
-	fi
+bad_usage() {
+	echo "LX zone install bad option"
+	echo "Available options are:"
+	echo "	-s <absolute-pathname>	Path to ZFS send stream or gzip thereof"
+	echo "	-t <absolute-pathname>	Path to tar archive or gzip thereof"
+	exit $ZONE_SUBPROC_USAGE
 }
 
-symlink()
-{
-	typeset src="$1"
-	typeset dst=$(fullpath "$2")
+while getopts "R:s:t:z:" opt
+do
+	case "$opt" in
+		R)	ZONEPATH="$OPTARG";;
+		z)	ZONENAME="$OPTARG";;
+		s)	ZFS_SEED="$OPTARG";;
+		t)	TAR_SEED="$OPTARG";;
+		*)	bad_usage ;;
+	esac
+done
+shift OPTIND-1
 
-	[[ -e "$dst" || -h "$dst" ]] && rm -f "$dst"
-	
-	if ! ln -s "$src" "$dst"; then
-		echo $(gettext "Aborting installation...")
-		exit 255
-	fi
-}
+if [[ $ZFS_SEED == "" && $TAR_SEED == "" ]]; then
+    echo "The -s <absolute-pathname> argument or the -t <absolute-pathname>"
+    echo "argument is required for LX installation."
+    bad_usage
+fi
 
-install_ln()
-{
-	typeset source="$1"
-	typeset target=$(fullpath "$2")
+if [[ $ZFS_SEED != "" && $TAR_SEED != "" ]]; then
+    echo "You must only specify one of -s or -t for LX installation."
+    bad_usage
+fi
 
-	log "    Installing \"$target\""
+# Set the ZONEPATH_DS variable so we know the zone's dataset.
+get_zonepath_ds $ZONEPATH
 
-	mv -f "$target" "$target.$tag" 2>/dev/null
+# Do something based on whatever ZFS_SEED is.
 
-	if ! ln -s "$source" "$target"; then
-		return 1
+if [[ -f $TAR_SEED ]]; then
+    type=`file -b $TAR_SEED | awk '{print $1}'`
+    if [[ $type == "gzip" ]]; then
+	args="-xzf"
+    else
+	args="-xf"
+    fi
+    cd $ZONEPATH
+    # Be very precise about permissions and ownership.
+    mkdir -m 0755 dev
+    chgrp sys dev
+    mkdir -m 0755 root
+    chgrp root sys
+    cd root
+    gtar $args $TAR_SEED
+    exit 0
+elif [[ ! -f $ZFS_SEED ]]; then
+    # Try and eat a snapshot or a filesystem.
+    outstr=`zfs list -Ht filesystem $ZFS_SEED 2>/dev/null | awk '{print $1}'`
+    if [[ $outstr == $ZFS_SEED ]]; then
+	# We have a zfs filesystem name.
+	# Snapshot it using today's date/time
+	snapname=`date -u "+%Y-%m-%d:%H:%M:%S"`
+	ZFS_SEED=$ZFS_SEED@$snapname
+	zfs snapshot $ZFS_SEED
+	if [[ $? != 0 ]]; then
+	    echo "ZFS snapshot ($ZFS_SEED) command failed ($?)."
+	    exit $ZONE_SUBPROC_FATAL
 	fi
+	# else continue on with the new snapshot...
+    fi
 
-	return 0
-}
-
-# If we weren't passed 3 arguments, exit now.
-[[ $# -lt 3 ]] && exit 254
-
-# Extract the brand directory name from the path.
-branddir=$(dirname "$0")
-zonename="$1"
-zoneroot="$2"
-install_src="3"
-install_root="$zoneroot/root"
-ZPOOL=`df $ZONEROOT | awk -F '[()]' '{split($2, field, "/"); print field[1]; }'`
-if [ -z "$ZPOOL" ]; then
-	ROOTDEV="none"
+    outstr=`zfs list -Ht snapshot $ZFS_SEED 2>/dev/null | awk '{print $1}'`
+    if [[ $outstr == $ZFS_SEED ]]; then
+	# Hmmm, we found a snapshot name!
+	echo "Cloning from snapshot $ZFS_SEED"
+	# zoneadm already created $ZONEPATH_DS, destroy it before we clone.
+	zfs destroy $ZONEPATH_DS
+	zfs clone $ZFS_SEED $ZONEPATH_DS
+	if [[ $? != 0 ]]; then
+	    echo "ZFS clone ($ZFS_SEED to $ZONEPATH_DS) failed ($?)."
+	    exit $ZONE_SUBPROC_FAIL
+	fi
+	# zfs promote $ZONEPATH_DS
+	# if [[ $? != 0 ]]; then
+	#    echo "ZFS promote ($ZONEPATH_DS) failed ($?)."
+	#    exit $ZONE_SUBPROC_FAIL
+	# fi
+    else 
+	echo "Seed file $ZFS_SEED $TAR_SEED not found."
+	bad_usage
+    fi
 else
-	ROOTDEV="/dev/$ZPOOL"
-fi
+    type=`file -b $ZFS_SEED | awk '{print $1}'`
 
-if [[ ! -f "$install_src" ]]; then
-	echo "$install_src: file not found\n"
-	exit 254
-fi
+    # For now, we are dependent on the output of file(1).
+    # I'm being cheesy in checking the first word of file(1)'s output.
+    if [[ $type == "ZFS" ]]; then
+	zfs recv -F $ZONEPATH_DS < $ZFS_SEED
+    elif [[ $type == "gzip" ]]; then
+	gunzip -c $ZFS_SEED | zfs recv -F $ZONEPATH_DS
+    else
+	echo "Seed file $ZFS_SEED not a ZFS receive (or compressed) one."
+	bad_usage
+    fi
 
-if [[ ! -d "$install_root" ]]; then
-	if ! mkdir -p "$install_root" 2>/dev/null; then
-		echo "Could not create install directory $install_root"
-		exit 254
-	fi
+    if [[ $? != 0 ]]; then
+	echo "ZFS receive command failed ($?)."
+	exit $ZONE_SUBPROC_FATAL
+    fi
 fi
 
-if ! ( cd "$install_root" && gtar -xzf "$install_src" ) ; then
-	echo "Error: extraction from tar archive failed"
-	exit 255
-fi
+# One Joyent-ism we need to clean up.
+rmdir $ZONEPATH/cores
+# And one we should probably adopt.
+zfs set devices=off $ZONEPATH_DS
 
-tag="lxsave_$(date +%m.%d.%Y@%T)"
-
-if [[ ! -d "$install_root" ]]; then
-	exit 255
-fi
-
-cd "$install_root"
-
-makedir native/dev
-makedir native/etc/default
-makedir native/etc/svc/volatile
-makedir native/lib
-makedir native/proc
-makedir native/tmp 1777
-makedir native/usr
-makedir native/var
-
-makedir mnt
-makedir opt
-makedir usr/local/bin
-makedir usr/local/include
-makedir usr/local/lib
-makedir usr/local/sbin
-makedir usr/local/share
-makedir usr/local/src
-
-makedir dev 0755
-makedir tmp 1777
-makedir proc 0555
-makedir boot 0755
-
-symlink /bin/sh sbin/sh
-symlink /bin/su usr/bin/su
-symlink /native/usr/lib/ld.so.1 usr/lib/ld.so.1
-
-libpam_so="$(echo lib/libpam.so.0.*)"
-libpam_misc="$(echo lib/libpam_misc.so.0.*)"
-libpamc_so="$(echo lib/libpamc.so.0.*)"
-
-symlink "/$libpam_so" lib/libpam.so.0
-symlink "/$libpam_misc" lib/libpam_misc.so.0
-symlink "/$libpamc_so" lib/libpamc.so.0
-
-makedir var/ld
-
-if ! crle -c var/ld/ld.config -l /native/lib:/native/usr/lib \
-     -s /native/lib/secure:/native/usr/lib/secure; then
-	exit 255
-fi
-
-mv -f etc/fstab etc/fstab.$tag 2>/dev/null
-
-cat > etc/fstab <<- EOF
-	$ROOTDEV	/			zfs	defaults	1 1
-	proc		/proc			proc	defaults	0 0
-EOF
-
-if [[ $? -ne 0 ]]; then
-	exit 255
-fi
-
-if [[ ! -e "$install_root/etc/hosts" ]]; then
-	cat > "$install_root/etc/hosts" <<-_EOF_
-		127.0.0.1		localhost
-	_EOF_
-fi
-
-#
-# Perform distribution-specific changes.
-#
-distro=""
-if [[ -f etc/redhat-release ]]; then
-	distro="redhat"
-elif [[ -f etc/lsb-release ]]; then
-	if egrep -s Ubuntu etc/lsb-release; then
-		distro="ubuntu"
-	elif [[ -f etc/debian_version ]]; then
-		distro="debian"
-	fi
-elif [[ -f etc/debian_version ]]; then
-	distro="debian"
-fi
-
-if [[ -z $distro ]]; then
-	exit 255
-fi
-
 exit 0
No differences encountered
--- old/usr/src/lib/brand/shared/zone/common.ksh	Wed Oct  5 00:33:22 2016
+++ new/usr/src/lib/brand/shared/zone/common.ksh	Wed Oct  5 00:33:22 2016
@@ -350,12 +350,10 @@
 	#
 	# Check if the image was created with a valid libc.so.1.
 	#
-	if [[ -f $ZONEROOT/lib/libc.so.1 ]]; then
-		hwcap=`moe -v -32 $ZONEROOT/lib/libc.so.1 2>&1`
-		if (( $? != 0 )); then
-			vlog "$f_hwcap_info" "$hwcap"
-			fail_fatal "$f_sanity_hwcap"
-		fi
+	hwcap=`moe -v -32 $ZONEROOT/lib/libc.so.1 2>&1`
+	if (( $? != 0 )); then
+		vlog "$f_hwcap_info" "$hwcap"
+		fail_fatal "$f_sanity_hwcap"
 	fi
 
 	( cd "$ZONEROOT" && \
@@ -1022,36 +1020,41 @@
 	return 0
 }
 
-e_cannot_wrap="%s: error: wrapper file already exists"
-e_baddir="Invalid '%s' directory within the zone"
-e_badfile="Invalid '%s' file within the zone"
-e_path_abs="Pathname specified to -a '%s' must be absolute."
-e_not_found="%s: error: file or directory not found."
-e_install_abort="Installation aborted."
-e_not_readable="Cannot read directory '%s'"
-e_not_dir="Error: must be a directory"
-e_unknown_archive="Error: Unknown archive format. Must be a flash archive, a cpio archive (can also be gzipped or bzipped), a pax XUSTAR archive, or a level 0 ufsdump archive."
-e_absolute_archive="Error: archive contains absolute paths instead of relative paths."
-e_mismatch_archive="Error: the archive top-level directory (%s) does not match the zonepath (%s)."
-e_tmpfile="Unable to create temporary file"
-e_root_full="Zonepath root %s exists and contains data; remove or move aside prior to install."
-f_mkdir="Unable to create directory %s."
-f_chmod="Unable to chmod directory %s."
-f_chown="Unable to chown directory %s."
-f_hwcap_info="HWCAP: %s\n"
-f_sanity_hwcap="The image was created with an incompatible libc.so.1 hwcap lofs mount.\n"\
+# Setup i18n output
+TEXTDOMAIN="SUNW_OST_OSCMD"
+export TEXTDOMAIN
+
+e_cannot_wrap=$(gettext "%s: error: wrapper file already exists")
+e_baddir=$(gettext "Invalid '%s' directory within the zone")
+e_badfile=$(gettext "Invalid '%s' file within the zone")
+e_path_abs=$(gettext "Pathname specified to -a '%s' must be absolute.")
+e_not_found=$(gettext "%s: error: file or directory not found.")
+e_install_abort=$(gettext "Installation aborted.")
+e_not_readable=$(gettext "Cannot read directory '%s'")
+e_not_dir=$(gettext "Error: must be a directory")
+e_unknown_archive=$(gettext "Error: Unknown archive format. Must be a flash archive, a cpio archive (can also be gzipped or bzipped), a pax XUSTAR archive, or a level 0 ufsdump archive.")
+e_absolute_archive=$(gettext "Error: archive contains absolute paths instead of relative paths.")
+e_mismatch_archive=$(gettext "Error: the archive top-level directory (%s) does not match the zonepath (%s).")
+e_tmpfile=$(gettext "Unable to create temporary file")
+e_root_full=$(gettext "Zonepath root %s exists and contains data; remove or move aside prior to install.")
+f_mkdir=$(gettext "Unable to create directory %s.")
+f_chmod=$(gettext "Unable to chmod directory %s.")
+f_chown=$(gettext "Unable to chown directory %s.")
+f_hwcap_info=$(gettext "HWCAP: %s\n")
+f_sanity_hwcap=$(gettext \
+"The image was created with an incompatible libc.so.1 hwcap lofs mount.\n"\
 "       The zone will not boot on this platform.  See the zone's\n"\
-"       documentation for the recommended way to create the archive."
+"       documentation for the recommended way to create the archive.")
 
-m_analyse_archive="Analysing the archive"
+m_analyse_archive=$(gettext "Analysing the archive")
 
-not_readable="Cannot read file '%s'"
-not_flar="Input is not a flash archive"
-bad_flar="Flash archive is a corrupt"
-bad_zfs_flar="Flash archive contains a ZFS send stream.\n\tRecreate the flar using the -L option with cpio or pax."
-f_unpack_failed="Unpacking the archive failed"
-unknown_archiver="Archiver %s is not supported"
-cmd_not_exec="Required command '%s' not executable!"
+not_readable=$(gettext "Cannot read file '%s'")
+not_flar=$(gettext "Input is not a flash archive")
+bad_flar=$(gettext "Flash archive is a corrupt")
+bad_zfs_flar=$(gettext "Flash archive contains a ZFS send stream.\n\tRecreate the flar using the -L option with cpio or pax.")
+f_unpack_failed=$(gettext "Unpacking the archive failed")
+unknown_archiver=$(gettext "Archiver %s is not supported")
+cmd_not_exec=$(gettext "Required command '%s' not executable!")
 
 #
 # Exit values used by the script, as #defined in <sys/zone.h>
No differences encountered
No differences encountered
No differences encountered
No differences encountered
No differences encountered
No differences encountered
No differences encountered
No differences encountered
--- old/usr/src/lib/libbrand/common/libbrand.c	Wed Oct  5 00:33:23 2016
+++ new/usr/src/lib/libbrand/common/libbrand.c	Wed Oct  5 00:33:23 2016
@@ -323,7 +323,6 @@
     const char *curr_zone)
 {
 	int dst, src;
-	static char *env_pool = NULL;
 
 	/*
 	 * Walk through the characters, substituting values as needed.
@@ -340,13 +339,6 @@
 		case '%':
 			dst += strlcpy(dbuf + dst, "%", dbuf_size - dst);
 			break;
-		case 'P':
-			if (env_pool == NULL)
-				env_pool = getenv("_ZONEADMD_ZPOOL");
-			if (env_pool == NULL)
-				break;
-			dst += strlcpy(dbuf + dst, env_pool, dbuf_size - dst);
-			break;
 		case 'R':
 			if (zonepath == NULL)
 				break;
No differences encountered
No differences encountered
No differences encountered
No differences encountered
No differences encountered
No differences encountered
No differences encountered
No differences encountered
No differences encountered
No differences encountered
No differences encountered
No differences encountered
No differences encountered
No differences encountered
--- old/usr/src/lib/libc/port/sys/zone.c	Wed Oct  5 00:33:24 2016
+++ new/usr/src/lib/libc/port/sys/zone.c	Wed Oct  5 00:33:24 2016
@@ -22,7 +22,6 @@
 /*
  * Copyright 2009 Sun Microsystems, Inc.  All rights reserved.
  * Use is subject to license terms.
- * Copyright 2011 Joyent Inc.  All rights reserved.
  */
 
 #include "lint.h"
@@ -41,8 +40,7 @@
 zoneid_t
 zone_create(const char *name, const char *root, const struct priv_set *privs,
     const char *rctls, size_t rctlsz, const char *zfs, size_t zfssz,
-    int *extended_error, int match, int doi, const bslabel_t *label, int flags,
-    zoneid_t req_zoneid)
+    int *extended_error, int match, int doi, const bslabel_t *label, int flags)
 {
 	zone_def  zd;
 	priv_data_t *d;
@@ -62,7 +60,6 @@
 	zd.doi = doi;
 	zd.label = label;
 	zd.flags = flags;
-	zd.zoneid = req_zoneid;
 
 	return ((zoneid_t)syscall(SYS_zone, ZONE_CREATE, &zd));
 }
No differences encountered
No differences encountered
No differences encountered
No differences encountered
No differences encountered
No differences encountered
No differences encountered
--- old/usr/src/lib/libdladm/common/linkprop.c	Wed Oct  5 00:33:25 2016
+++ new/usr/src/lib/libdladm/common/linkprop.c	Wed Oct  5 00:33:25 2016
@@ -154,13 +154,11 @@
 			get_bridge_pvid, get_protection, get_rxrings,
 			get_txrings, get_cntavail, get_secondary_macs,
 			get_allowedips, get_allowedcids, get_pool,
-			get_rings_range, get_linkmode_prop,
-			get_promisc_filtered;
+			get_rings_range, get_linkmode_prop;
 
 static pd_setf_t	set_zone, set_rate, set_powermode, set_radio,
 			set_public_prop, set_resource, set_stp_prop,
-			set_bridge_forward, set_bridge_pvid, set_secondary_macs,
-			set_promisc_filtered;
+			set_bridge_forward, set_bridge_pvid, set_secondary_macs;
 
 static pd_checkf_t	check_zone, check_autopush, check_rate, check_hoplimit,
 			check_encaplim, check_uint32, check_maxbw, check_cpus,
@@ -384,8 +382,6 @@
 
 	{ MAC_PROP_IB_LINKMODE,	sizeof (uint32_t),	"linkmode"},
 
-	{ MAC_PROP_VN_PROMISC_FILTERED,	sizeof (boolean_t), "promisc-filtered"},
-
 	{ MAC_PROP_SECONDARY_ADDRS, sizeof (mac_secondary_addr_t),
 	    "secondary-macs"},
 
@@ -443,11 +439,6 @@
 	{ "dhcp-nospoof",	MPT_DHCPNOSPOOF	},
 };
 
-static  val_desc_t	link_promisc_filtered_vals[] = {
-	{ "off",	B_FALSE },
-	{ "on",		B_TRUE },
-};
-
 static val_desc_t	dladm_wlan_radio_vals[] = {
 	{ "on",		DLADM_WLAN_RADIO_ON	},
 	{ "off",	DLADM_WLAN_RADIO_OFF	}
@@ -764,12 +755,6 @@
 	    set_resource, NULL, get_protection, check_prop, 0,
 	    DATALINK_CLASS_ALL, DATALINK_ANY_MEDIATYPE },
 
-	{ "promisc-filtered", { "on", 1 },
-	    link_promisc_filtered_vals, VALCNT(link_promisc_filtered_vals),
-	    set_promisc_filtered, NULL, get_promisc_filtered, check_prop, 0,
-	    DATALINK_CLASS_VNIC, DATALINK_ANY_MEDIATYPE },
-
-
 	{ "allowed-ips", { "--", 0 },
 	    NULL, 0, set_resource, NULL,
 	    get_allowedips, check_allowedips, PD_CHECK_ALLOC,
@@ -1511,12 +1496,17 @@
 }
 
 typedef int (*zone_get_devroot_t)(char *, char *, size_t);
+typedef int (*zone_get_brand_t)(char *, char *, size_t);
 
 static int
 i_dladm_get_zone_dev(char *zone_name, char *dev, size_t devlen)
 {
 	char			root[MAXPATHLEN];
+	char			brand[MAXPATHLEN]; /* Overkill, for sure. */
+	static char		*full_native_path = "/native/dev";
+	char			*native_dev_path = full_native_path;
 	zone_get_devroot_t	real_zone_get_devroot;
+	zone_get_brand_t	real_zone_get_brand;
 	void			*dlhandle;
 	void			*sym;
 	int			ret;
@@ -1528,11 +1518,28 @@
 		(void) dlclose(dlhandle);
 		return (-1);
 	}
-
 	real_zone_get_devroot = (zone_get_devroot_t)sym;
 
+	if ((sym = dlsym(dlhandle, "zone_get_brand")) == NULL) {
+		(void) dlclose(dlhandle);
+		return (-1);
+	}
+	real_zone_get_brand = (zone_get_devroot_t)sym;
+
+	/* Have "/dev" be LX-agile for possibility of "/native/dev". */
+	ret = real_zone_get_brand(zone_name, brand, sizeof (brand));
+	if (ret != 0) {
+		(void) dlclose(dlhandle);
+		return (ret);
+	}
+	/* Can use strcmp with constant string... */
+	if (strcmp(brand, "lx") != 0) {
+		/* Non-LX zone, don't use "/native/dev" */
+		native_dev_path += 7;	/* strlen("/native") */
+	}
+
 	if ((ret = real_zone_get_devroot(zone_name, root, sizeof (root))) == 0)
-		(void) snprintf(dev, devlen, "%s%s", root, "/dev");
+		(void) snprintf(dev, devlen, "%s%s", root, native_dev_path);
 	(void) dlclose(dlhandle);
 	return (ret);
 }
@@ -1601,9 +1608,6 @@
 	if (zid_new == zid_old)
 		return (DLADM_STATUS_OK);
 
-	if (flags & DLADM_OPT_TRANSIENT)
-		dzp->diz_transient = B_TRUE;
-
 	if ((status = set_public_prop(handle, pdp, linkid, vdp, val_cnt,
 	    flags, media)) != DLADM_STATUS_OK)
 		return (status);
@@ -4844,51 +4848,4 @@
 
 	*val_cnt = 1;
 	return (DLADM_STATUS_OK);
-}
-
-/*ARGSUSED*/
-static dladm_status_t
-get_promisc_filtered(dladm_handle_t handle, prop_desc_t *pdp,
-    datalink_id_t linkid, char **prop_val, uint_t *val_cnt,
-    datalink_media_t media, uint_t flags, uint_t *perm_flags)
-{
-	char			*s;
-	dladm_status_t		status;
-	boolean_t		filt;
-
-	status = i_dladm_get_public_prop(handle, linkid, pdp->pd_name, flags,
-	    perm_flags, &filt, sizeof (filt));
-	if (status != DLADM_STATUS_OK)
-		return (status);
-
-	if (filt != 0)
-		s = link_promisc_filtered_vals[1].vd_name;
-	else
-		s = link_promisc_filtered_vals[0].vd_name;
-	(void) snprintf(prop_val[0], DLADM_STRSIZE, "%s", s);
-
-	*val_cnt = 1;
-	return (DLADM_STATUS_OK);
-}
-
-/* ARGSUSED */
-static dladm_status_t
-set_promisc_filtered(dladm_handle_t handle, prop_desc_t *pdp,
-    datalink_id_t linkid, val_desc_t *vdp, uint_t val_cnt, uint_t flags,
-    datalink_media_t media)
-{
-	dld_ioc_macprop_t	*dip;
-	dladm_status_t		status = DLADM_STATUS_OK;
-
-	dip = i_dladm_buf_alloc_by_name(0, linkid, pdp->pd_name,
-	    0, &status);
-
-	if (dip == NULL)
-		return (status);
-
-	(void) memcpy(dip->pr_val, &vdp->vd_val, dip->pr_valsize);
-	status = i_dladm_macprop(handle, dip, B_TRUE);
-
-	free(dip);
-	return (status);
 }
--- old/usr/src/lib/libdtrace/common/dt_open.c	Wed Oct  5 00:33:25 2016
+++ new/usr/src/lib/libdtrace/common/dt_open.c	Wed Oct  5 00:33:25 2016
@@ -21,7 +21,7 @@
 
 /*
  * Copyright (c) 2003, 2010, Oracle and/or its affiliates. All rights reserved.
- * Copyright (c) 2015, Joyent, Inc.
+ * Copyright (c) 2013, Joyent, Inc. All rights reserved.
  * Copyright (c) 2012, 2016 by Delphix. All rights reserved.
  */
 
@@ -1147,13 +1147,13 @@
 	 * Add intrinsic pointer types that are needed to initialize printf
 	 * format dictionary types (see table in dt_printf.c).
 	 */
-	(void) ctf_add_pointer(dmp->dm_ctfp, CTF_ADD_ROOT, NULL,
+	(void) ctf_add_pointer(dmp->dm_ctfp, CTF_ADD_ROOT,
 	    ctf_lookup_by_name(dmp->dm_ctfp, "void"));
 
-	(void) ctf_add_pointer(dmp->dm_ctfp, CTF_ADD_ROOT, NULL,
+	(void) ctf_add_pointer(dmp->dm_ctfp, CTF_ADD_ROOT,
 	    ctf_lookup_by_name(dmp->dm_ctfp, "char"));
 
-	(void) ctf_add_pointer(dmp->dm_ctfp, CTF_ADD_ROOT, NULL,
+	(void) ctf_add_pointer(dmp->dm_ctfp, CTF_ADD_ROOT,
 	    ctf_lookup_by_name(dmp->dm_ctfp, "int"));
 
 	if (ctf_update(dmp->dm_ctfp) != 0) {
@@ -1213,11 +1213,11 @@
 	ctc.ctc_argc = 0;
 	ctc.ctc_flags = 0;
 
-	dtp->dt_type_func = ctf_add_funcptr(dmp->dm_ctfp,
+	dtp->dt_type_func = ctf_add_function(dmp->dm_ctfp,
 	    CTF_ADD_ROOT, &ctc, NULL);
 
-	dtp->dt_type_fptr = ctf_add_pointer(dmp->dm_ctfp, CTF_ADD_ROOT, NULL,
-	    dtp->dt_type_func);
+	dtp->dt_type_fptr = ctf_add_pointer(dmp->dm_ctfp,
+	    CTF_ADD_ROOT, dtp->dt_type_func);
 
 	/*
 	 * We also insert CTF definitions for the special D intrinsic types
No differences encountered
No differences encountered
No differences encountered
No differences encountered
--- old/usr/src/lib/libproc/common/Pcontrol.h	Wed Oct  5 00:33:26 2016
+++ new/usr/src/lib/libproc/common/Pcontrol.h	Wed Oct  5 00:33:26 2016
@@ -123,7 +123,6 @@
 	size_t	file_shstrsz;	/* section header string table size */
 	uintptr_t *file_saddrs; /* section header addresses */
 	uint_t  file_nsaddrs;   /* number of section header addresses */
-	boolean_t file_cvt;	/* Have we tried to convert this? */
 } file_info_t;
 
 typedef struct map_info {	/* description of an address space mapping */
No differences encountered
No differences encountered
--- old/usr/src/lib/libproc/common/Psymtab.c	Wed Oct  5 00:33:26 2016
+++ new/usr/src/lib/libproc/common/Psymtab.c	Wed Oct  5 00:33:26 2016
@@ -744,58 +744,6 @@
 	return (Plmid_to_loadobj(P, PR_LMID_EVERY, name));
 }
 
-/*
- * We've been given a file_info_t which doesn't have any CTF. However, it may
- * have information that's in a format that we could convert if on the fly.
- * We'll first try to convert the alternate debug file, if present, and then
- * move onto the default file. The reason we prefer the alternate debug file is
- * that if both exist, then it likely has any usable debugging information.
- */
-static ctf_file_t *
-Pconvert_file_ctf(file_info_t *fptr)
-{
-	int err;
-	ctf_file_t *fp;
-	char errmsg[1024];
-
-	/*
-	 * Provide an opt in.
-	 */
-	if (getenv("LIBPROC_CTFCONVERT") == NULL)
-		return (NULL);
-
-	/*
-	 * If we've already attempted to call this, then that's it. No reason to
-	 * pretend we'll be more successful again another time.
-	 */
-	if (fptr->file_cvt == B_TRUE)
-		return (NULL);
-	fptr->file_cvt = B_TRUE;
-
-	fp = NULL;
-	if (fptr->file_dbgelf != NULL) {
-		fp = ctf_elfconvert(fptr->file_fd, fptr->file_dbgelf, NULL, 1,
-		    0, &err, errmsg, sizeof (errmsg));
-		if (fp == NULL) {
-			dprintf("failed to convert %s: %s\n", fptr->file_pname,
-			    err == ECTF_CONVBKERR ? errmsg : ctf_errmsg(err));
-		}
-	}
-	if (fp == NULL) {
-		fp = ctf_elfconvert(fptr->file_fd, fptr->file_elf, NULL, 1,
-		    0, &err, errmsg, sizeof (errmsg));
-		if (fp == NULL) {
-			dprintf("failed to convert %s: %s\n", fptr->file_pname,
-			    err == ECTF_CONVBKERR ? errmsg : ctf_errmsg(err));
-		}
-	}
-	if (fp != NULL) {
-		fptr->file_ctfp = fp;
-	}
-
-	return (NULL);
-}
-
 ctf_file_t *
 Pbuild_file_ctf(struct ps_prochandle *P, file_info_t *fptr)
 {
@@ -808,9 +756,8 @@
 
 	Pbuild_file_symtab(P, fptr);
 
-	if (fptr->file_ctf_size == 0) {
-		return (Pconvert_file_ctf(fptr));
-	}
+	if (fptr->file_ctf_size == 0)
+		return (NULL);
 
 	symp = fptr->file_ctf_dyn ? &fptr->file_dynsym : &fptr->file_symtab;
 	if (symp->sym_data_pri == NULL)
No differences encountered
--- old/usr/src/lib/libzonecfg/common/getzoneent.c	Wed Oct  5 00:33:26 2016
+++ new/usr/src/lib/libzonecfg/common/getzoneent.c	Wed Oct  5 00:33:26 2016
@@ -128,8 +128,6 @@
 			/* skip comment lines */
 			continue;
 		}
-
-		/* zonename */
 		p = gettok(&cp);
 		if (*p == '\0' || strlen(p) >= ZONENAME_MAX) {
 			/*
@@ -139,7 +137,6 @@
 		}
 		(void) strlcpy(ze->zone_name, p, ZONENAME_MAX);
 
-		/* state */
 		p = gettok(&cp);
 		if (*p == '\0') {
 			/* state field should not be empty */
@@ -156,7 +153,6 @@
 			continue;
 		}
 
-		/* zonepath */
 		p = gettok(&cp);
 		if (strlen(p) >= MAXPATHLEN) {
 			/* very long paths are not allowed */
@@ -164,35 +160,10 @@
 		}
 		(void) strlcpy(ze->zone_path, p, MAXPATHLEN);
 
-		/* uuid */
 		p = gettok(&cp);
 		if (uuid_parse(p, ze->zone_uuid) == -1)
 			uuid_clear(ze->zone_uuid);
 
-		/* brand [optional] */
-		p = gettok(&cp);
-		if (strlen(p) >= MAXNAMELEN) {
-			/* very long names are not allowed */
-			continue;
-		}
-		(void) strlcpy(ze->zone_brand, p, MAXNAMELEN);
-
-		/* IP type [optional] */
-		p = gettok(&cp);
-		if (strlen(p) >= MAXNAMELEN) {
-			/* very long names are not allowed */
-			continue;
-		}
-		ze->zone_iptype = ZS_SHARED;
-		if (*p == 'e') {
-			ze->zone_iptype = ZS_EXCLUSIVE;
-		}
-
-		/* debug ID [optional] */
-		p = gettok(&cp);
-		if (*p != '\0')
-			ze->zone_did = atoi(p);
-
 		break;
 	}
 
@@ -323,14 +294,12 @@
 	char buf[MAX_INDEX_LEN];
 	int tmp_file_desc, lock_fd, err;
 	boolean_t exist, need_quotes;
-	char *cp, *tmpp;
+	char *cp;
 	char tmp_path[MAXPATHLEN];
 	char path[MAXPATHLEN];
 	char uuidstr[UUID_PRINTABLE_STRING_LENGTH];
 	size_t namelen;
-	const char *zone_name, *zone_state, *zone_path, *zone_uuid,
-	    *zone_brand = "", *zone_iptype;
-	zoneid_t zone_did;
+	const char *zone_name, *zone_state, *zone_path, *zone_uuid;
 
 	assert(ze != NULL);
 
@@ -383,9 +352,6 @@
 	exist = B_FALSE;
 	zone_name = ze->zone_name;
 	namelen = strlen(zone_name);
-	zone_brand = ze->zone_brand;
-	zone_iptype = (ze->zone_iptype == ZS_SHARED ? "sh" : "ex");
-	zone_did = ze->zone_did;
 	for (;;) {
 		if (fgets(buf, sizeof (buf), index_file) == NULL) {
 			if (operation == PZE_ADD && !exist) {
@@ -440,11 +406,6 @@
 		}
 		zone_path = gettok(&cp);
 		zone_uuid = gettok(&cp);
-		zone_brand = gettok(&cp);
-		zone_iptype = gettok(&cp);
-		tmpp = gettok(&cp);
-		if (*tmpp != '\0')
-			zone_did = atoi(tmpp);
 
 		switch (operation) {
 		case PZE_ADD:
@@ -459,6 +420,14 @@
 			 */
 			if (ze->zone_state >= 0) {
 				zone_state = zone_state_str(ze->zone_state);
+
+				/*
+				 * If the caller is uninstalling this zone,
+				 * then wipe out the uuid.  The zone's contents
+				 * are no longer known.
+				 */
+				if (ze->zone_state < ZONE_STATE_INSTALLED)
+					zone_uuid = "";
 			}
 
 			/* If a new name is supplied, use it. */
@@ -467,27 +436,6 @@
 
 			if (ze->zone_path[0] != '\0')
 				zone_path = ze->zone_path;
-
-			/* If new UUID provided, replace it */
-			if (!uuid_is_null(ze->zone_uuid)) {
-				uuid_unparse(ze->zone_uuid, uuidstr);
-				zone_uuid = uuidstr;
-			}
-
-			/* If a brand is supplied, use it. */
-			if (ze->zone_brand[0] != '\0') {
-				zone_brand = ze->zone_brand;
-
-				/*
-				 * Since the brand, iptype and did are optional,
-				 * we we only reset the iptype and did if the
-				 * brand is provided.
-				 */
-				zone_iptype = (ze->zone_iptype == ZS_SHARED ?
-				    "sh" : "ex");
-				zone_did = ze->zone_did;
-			}
-
 			break;
 
 		case PZE_REMOVE:
@@ -519,17 +467,9 @@
 		 * method for escaping them.
 		 */
 		need_quotes = (strchr(zone_path, ':') != NULL);
-
-		if (*zone_brand != '\0') {
-			(void) fprintf(tmp_file, "%s:%s:%s%s%s:%s:%s:%s:%d\n",
-			    zone_name, zone_state, need_quotes ? "\"" : "",
-			    zone_path, need_quotes ? "\"" : "", zone_uuid,
-			    zone_brand, zone_iptype, zone_did);
-		} else {
-			(void) fprintf(tmp_file, "%s:%s:%s%s%s:%s\n", zone_name,
-			    zone_state, need_quotes ? "\"" : "", zone_path,
-			    need_quotes ? "\"" : "", zone_uuid);
-		}
+		(void) fprintf(tmp_file, "%s:%s:%s%s%s:%s\n", zone_name,
+		    zone_state, need_quotes ? "\"" : "", zone_path,
+		    need_quotes ? "\"" : "", zone_uuid);
 		exist = B_TRUE;
 	}
 
